package org.crosswire.android.bishop;

import org.crosswire.android.sword.SWMgr;
import org.crosswire.android.sword.SWModule;

import android.app.Dialog;
import android.content.Context;
import android.os.Bundle;
import android.view.ViewGroup.LayoutParams;
import android.webkit.WebView;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

public class About extends Dialog {

	LinearLayout mainLayout;
	TextView title;
	TextView version;
	TextView author;
	WebView  wv;
	Button   ok;
	
	public About(Context context) {
		super(context);
	}

	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		this.setTitle("About The SWORD Project");
		mainLayout = new LinearLayout(this.getContext());
		mainLayout.setOrientation(LinearLayout.VERTICAL);
		
		SWMgr mgr = new SWMgr();
		wv = new WebView(getContext());
		wv.setPadding(10, 10, 10, 10);
		String str = 
			"<center><h1>Bishop</h1></center>"
			+"<center><h2>v.0.9.0</h2></center>"
	        + "<center><h3>The SWORD Project Engine v" + mgr.version() + "</h3></center><br/><br/>"
			+"<center><h3>CrossWire Bible Society</h3></center>"
			+"<center><h4><a href=\"http://crosswire.org\">http://crosswire.org</a></h4></center>"
			+"<center>The SWORD Project Android Reader</center><br/><br/>"
			+"Download and unzip modules (Bibles, commentaries, lexica, and other study helps) in RawZip format "
			+"from <a href=\"http://crosswire.org/sword/modules\">http://crosswire.org/sword/modules</a> to your sdcard "
			+"under a folder called /sword/ (e.g., /sdcard/sword/)<br/><br/>"
			+"--------<br/>"
			+"Installed Modules<br/>"
			+"--------<br/><br/>";
        
        SWMgr.ModInfo mods[] = mgr.getModInfoList();
        str += mods.length + " modules installed to: " + mgr.getConfigPath() + "<br/>";
        str += "--------<br/><br/>";
        for (SWMgr.ModInfo mi : mods) {
        	str += mi.description + " (" + mi.name + ")<br/>";
	        str += "--------<br/>";
	        SWModule module = mgr.getModuleByName(mi.name);
            String about = module.getConfigEntry("About");
			if (about != null) {
				about = about.replaceAll("\\\\pard", "");
				about = about.replaceAll("\\\\par", "<br />");
				about = about.replaceAll("\\\\\\w+", "");
				str += about;
			}
		}
		wv.loadData(str, "text/html", "utf-8");
		mainLayout.addView(wv);
		addContentView(mainLayout, new LinearLayout.LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.FILL_PARENT));
	}

}
